' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2007                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************

' -----------------------------------------------------------------
' FVX Sample Program
' C_CAO
'
' 쐬 : D.Yamaguchi
'
'  : 2007/01/18 
' -----------------------------------------------------------------

Imports System.Windows.Forms
Imports FVDATASLib
Imports Microsoft

Public Class frmPtnDisp

    Private Sub FrmPtnDisp_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim dblMagnification As Double
        Dim intPixelX As Integer
        Dim intPixelY As Integer

        AxFvxDisplayEx1.CreateDisplay()

        frmMain.ApplyChanges()

        '\{擾
        dblMagnification = fnGetMag()

        'fBXvCTCY
        subDisplayResize(dblMagnification)

        'GbW\
        subEdgeDataDisp()

        '\ʒul
        intPixelX = Me.Width
        intPixelY = Me.Height

        Me.Left = frmMain.Left + (intPixelX / 4) + frmMain.AxFvxDisplayEx1.Left
        Me.Top = frmMain.Top + (intPixelY / 2) + frmMain.AxFvxDisplayEx1.Top

        chkEdgeDisp.Checked = True

    End Sub

    'GbW\ ON/OFF
    Private Sub chkEdgeDisp_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkEdgeDisp.CheckedChanged

        Dim shtKind As Short
        Dim shtMode As Short

        Try
            shtKind = 1
            'GbW\
            If chkEdgeDisp.Checked = True Then
                shtMode = 2
                frmMain.subEdgDisp(shtKind, shtMode)
                'GbW
            Else
                shtMode = 0
                frmMain.subEdgDisp(shtKind, shtMode)

                'ʒmʒu\
                subPatanCenterMarkDisp()
            End If

            Exit Sub
        Catch es As System.Exception
            MsgBox("p^GbW\s", vbExclamation, "G[")
        End Try

    End Sub

    'p^ʒmʒuW(l)\
    Public Sub subPatanCenterMarkDisp()

        Dim dblXPos As Double
        Dim dblYPos As Double

        'ʒmʒu\
        frmMain.AxFvxPattern1.GetCenterMarkOffset(dblXPos, dblYPos)

        lblCenterMark.Text = "ʒmʒu( " & VisualBasic.Format(dblXPos, "##0.0") & ", " & VisualBasic.Format(dblYPos, "##0.0") & " )"
        fnCrossCursor(dblXPos, dblYPos)

    End Sub

    'ANeBuGbW̍ĕ`
    Private Sub Form_Activate()

        Dim dblMagnification As Double

        'p[^ݒ
        frmMain.ApplyChanges()

        '\{擾
        dblMagnification = fnGetMag()

        'fBXvCTCY
        subDisplayResize(dblMagnification)

        'GbW\
        subEdgeDataDisp()

    End Sub

    'GbW\
    Private Sub subEdgeDataDisp()

        Dim intKind As Integer  '0:摜 1:p^
        Dim intMode As Integer  '0:Clear 1:Draw 2:Clear&Draw

        Me.AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(0, 0, 255)

        intKind = 1

        If chkEdgeDisp.Checked = True Then
            intMode = 2
        Else
            intMode = 0
        End If

        frmMain.subEdgDisp(intKind, intMode)

    End Sub

    'fBXvCEt[TCYύX
    Private Sub subDisplayResize(ByVal dblMagnification As Double)

        Dim dblXPos As Double
        Dim dblYPos As Double
        Dim pRect As New FvRectangle    'g傷̈
        Dim dblPatternXsize As Double
        Dim dblPatternYsize As Double
        Dim sngMinWidth As Single
        Dim sngMinHeight As Single

        frmMain.AxFvxPattern1.GetCenterMarkOffset(dblXPos, dblYPos)
        frmMain.AxFvxPattern1.GetPatternArea(pRect)

        dblPatternXsize = pRect.xe - pRect.xs + 1
        dblPatternYsize = pRect.ye - pRect.ys + 1

        Me.Width = ((dblPatternXsize * dblMagnification) + 50)
        Me.Height = ((dblPatternYsize * dblMagnification) + 150)

        sngMinWidth = 200 + 50
        sngMinHeight = 180 + 50

        If Me.Width < sngMinWidth Then
            Me.Width = sngMinWidth
        End If

        If Me.Height < sngMinHeight Then
            Me.Height = sngMinHeight
        End If

        dblPatternXsize = pRect.xe - pRect.xs + 1
        dblPatternYsize = pRect.ye - pRect.ys + 1

        AxFvxDisplayEx1.Magnification = dblMagnification

        AxFvxDisplayEx1.Left = ((Me.Width) - (dblPatternXsize * dblMagnification)) / 2
        AxFvxDisplayEx1.Top = ((Me.Height) - (dblPatternYsize * dblMagnification)) / 2
        AxFvxDisplayEx1.Width = (dblPatternXsize) * dblMagnification
        AxFvxDisplayEx1.Height = (dblPatternYsize) * dblMagnification

        AxFvxDisplayEx1.DrawImage(frmMain.AxFvxPattern1.GetOcx())

    End Sub

    Public Sub fnCrossCursor(ByVal dblXPos As Double, ByVal dblYPos As Double)

        Dim pLine1 As New FvLineSegment
        Dim intId1 As Integer

        pLine1.xs = dblXPos - 5
        pLine1.ys = dblYPos - 5
        pLine1.xe = dblXPos + 5
        pLine1.ye = dblYPos + 5
        intId1 = AxFvxDisplayEx1.DrawData(0, pLine1)

        pLine1.xs = dblXPos + 5
        pLine1.ys = dblYPos - 5
        pLine1.xe = dblXPos - 5
        pLine1.ye = dblYPos + 5
        intId1 = AxFvxDisplayEx1.DrawData(0, pLine1)

    End Sub

    Private Function fnGetMag() As Double

        Dim dblMagnification As Double

        dblMagnification = HScrlImageScale.Value
        dblMagnification = (dblMagnification - ((dblMagnification - 1) * 0.5))

        fnGetMag = dblMagnification

    End Function

    Private Sub Form_Unload(ByVal Cancel As Integer)

        AxFvxDisplayEx1.DestroyDisplay()

    End Sub

    Private Sub HScrlImageScale_Change()

        Dim dblMagnification As Double

        dblMagnification = HScrlImageScale.Value
        dblMagnification = (dblMagnification - ((dblMagnification - 1) * 0.5))
        lblImageScale.Text = "~" & VisualBasic.Format(dblMagnification, "0.0")
        subDisplayResize(dblMagnification)

    End Sub

    Private Sub HScrlImageScale_Scroll(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ScrollEventArgs) Handles HScrlImageScale.Scroll

        Dim dblMagnification As Double

        dblMagnification = HScrlImageScale.Value
        dblMagnification = (dblMagnification - ((dblMagnification - 1) * 0.5))
        lblImageScale.Text = "~" & VisualBasic.Format(dblMagnification, "0.0")
        subDisplayResize(dblMagnification)

    End Sub

End Class
